MainProgram:
   GoSub Initialization
   while true
      if !ButtonEnabled(CreateBtn) then setEdit "Status",udp_Status("udp1")
   wend
end
//-----------------------------------------------------------------------
Initialization:
    xytext 30,3,"Local Machine's","Ms San Serif",15,fs_Bold|fs_Underlined     
    xytext 480,3,"Send Your Data To","Ms San Serif",15,fs_Bold|fs_Underlined     
    xytext 2,30,"IP  :","",15,fs_Bold \ xytext 2,60,"Port:","",15,fs_Bold     
    xytext 432,30,"IP  :","",15,fs_Bold \ xytext 432,60,"Port:","",15,fs_Bold     
    xytext 412,90,"Status:","",15,fs_Bold
    AddEdit "LclIP",70,30,120,0,tcp_LocalIP()  \  AddEdit "LclPort",70,60,120,0,"50001"
    readonlyedit "LclIP"
    AddEdit "RmtIp",510,30,120,0,tcp_LocalIP() \ AddEdit "RmtPort",510,60,120,0,"50001"        
    AddEdit "Status",510,90,280,0,"No Udp Socket...Create one" \ ReadOnlyedit "Status"
    CreateBtn = "&Create A UDP Socket"  \ AddButton CreateBtn,60,90,200    
    InstBtn   = "&Instructions"  \ AddButton InstBtn,260,20,100    

    ERectangle 10,130,790,173,5,Blue \ Line 380,130,380,600,5,blue
    xyText 100,138,"Local Data","",15,fs_Bold \ xyText 500,138,"Remote Data","",15,fs_Bold

    AddSlider "Here",10,210,250,-100,100
    AddSlider "There",410,210,250,-100,100 \ EnableSlider "There",0
    xystring 5,180,  "-100      Analog Input    100"
    xystring 405,180,"-100      Analog Input    100"
    AddEdit "Here",80,250,100,0,-100 \  AddEdit "There",480,250,100,0,-100
    ReadOnlyEdit "Here" \  ReadOnlyEdit "There"    
    AddListBox "List0",20,380,200 \ AddListBox "List1",420,380,200
    EnableListBox "List1",0
    for i=0 to 7
       if i < 2  
          data LEDs;255
          AddEdit "LEDs"+i,400*i+220,305,100,0,"0x"+Hex(LEDs[i])+"="+LEDs[i] 
          ReadOnlyEdit "LEDs"+i 
          xyText 400*i+20,360,"List Selection"   \ xyText 400*i+25,290,"Digital I/O"
          AddMemo "Text"+i,20+400*i,430,300,150 \ xyText 400*i+20,410,"Text Data"
          SetMemoScrollBars "Text"+i,1 
       endif   
       AddCheckbox "Sw0"+i,20+i*25,310," ",1 \AddCheckbox "Sw1"+i,420+i*25,310," ",1
       EnableCheckBox "Sw1"+i,0 \ AddListBoxItem "List0","Choice"+(i+1)
       AddListBoxItem "List1","Choice"+(i+1) 
    Next   
    SetListBox "List0",1 \ SetListBox "List1",1 \ ReadOnlyMemo "Text1"
    onSlider slHandler \ onCheckBox cbHandler \ OnListBox lbHandler
    onButton bHandler \ onMemo mHandler 
Return
//-----------------------------------------------------------------------
SendData:
    if ButtonEnabled(CreateBtn) then return
    s = "" \ BuffPrintB s,getSliderpos("Here"),ToByte(LEDs[0])
    BuffPrintB s,GetListBox("List0"),GetMemoText("Text0")
    n = ToNumber(getEdit("RmtPort"))
    if !IsNumber(n) then n = 50001 \ SetEdit "RmtPort",n
    n=UDP_Send("udp1",s,getedit("RmtIp"),n)
Return
//-----------------------------------------------------------------------
slHandler:
   lsl = LastSlider() \ x = getSliderpos(lsl)\ setedit lsl,x
   if lsl=="Here" then GoSub SendData
   onSlider slHandler
Return
//-----------------------------------------------------------------------
cbHandler:
   lcb = LastCheckBox() \ n=tonumber(right(lcb,2)) \ nn=n/10 \ n=n#10
   LEDs[nn] = MakeBit(LEDs[nn],7-n,getCheckBox(lcb))
   SetEdit "LEDs"+nn,"0x"+Hex(LEDs[nn])+"="+LEDs[nn]
   if nn==0 then GoSub SendData
   onCheckBox cbHandler
Return
//-----------------------------------------------------------------------
lbHandler:
   llb = LastListBox()
   if llb == "List0" then GoSub SendData
   onListBox lbHandler
Return
//-----------------------------------------------------------------------
bHandler:
   lb=LastButton()
   if lb==CreateBtn
       n = ToNumber(GetEdit("LclPort"))
       if !IsNumber(n) then n = 50001 \ SetEdit "LclPort",n
       n=udp_Start("udp1",n) \ enablebutton lb,0 \ enableedit "LclPort",0
       n=UDP_Read("udp1")  //clear the buffer
       onUDP udpHandler 
   elseif lb == InstBtn
       GoSub Instructions    
   endif    
   onButton bHandler
Return
//-----------------------------------------------------------------------
mHandler:
   lsm = LastMemo()
   if lsm=="Text0" then GoSub SendData
   onMemo mHandler
Return
//-----------------------------------------------------------------------
udpHandler:
   if udp_buffcount("udp1") >= 9
      ss = udp_read("udp1")
      SetSliderPos "There",BuffReadI(ss,0)
      LEDs[1] = BuffReadB(ss,4)
      for i=0 to 7
          SetCheckBox "Sw1"+i,LEDs[1] & 2^(7-i)
      next
      SetListBox "List1",BuffReadI(ss,5)
      ss = BuffRead(ss,9,0)
      SetMemoText "Text1",ss 
      SetMemoSelection "Text1",MemoLinesCount("Text1")+1,-1,0
      FocusMemo "Text0"
   endif
   onudp udpHandler
Return
//-----------------------------------------------------------------------
Instructions:
    if vType(InstFt)then InstFt = MsgBox(IM) \ return
    data IM;ProgName()
    data IM;"This is a demo for the UDP support in RobotBASIC V4.0.0",""
    data IM;"You can use this demo to send and receive data between two instances"
    data IM;"of the program. The instances can be on the same machine or on "
    data IM;"different machines on the same LAN or even across the internet.",""
    data IM;"To start the sending and receiving you must create a socket. But before"
    data IM;"you do this you need to decide what port you want to receive on and "
    data IM;"type in the value in the Port field on the left. You must do this for"
    data IM;"both instances.",""
    data IM;"NOTE...NOTE...if you run both instances on the same machine then you"
    data IM;"MUST NOT have the same receive port. You MUST have different Local ports"
    data IM;"for each instance.","" 
    data IM;"Also on both instances you must type in the IP address on the right"
    data IM;"side. This has to be the IP address of the other instance. To help "
    data IM;"with this, each instance shows its local IP on the left side. If both"
    data IM;"instances of the program are on the same machine then the IP address"
    data IM;"will be the same in both cases.",""
    data IM;"You also need to do the same for the Port field which is the port number"
    data IM;"the other instance is listening on.",""
    data IM;"So on the left type in the port you want to listen on and on the right"
    data IM;"type the IP and Port of the other instance.",""
    data IM;"Once you have done this you should press the button 'Create A UDP Socket'"
    data IM;"which will start sending and receiving.",""
    data IM;"Now any changes you make to the controls on the left side of the screen"
    data IM;"would be reflected on the other instance's right side and any changes done"
    data IM;"to the other instance's controls on the left will be reflected on this"
    data IM;"instance's right side.",""
    data IM;"This demonstrates sending and receiving binary and text data using the UDP"
    data IM;"protocol.",""
    data IM;"You can even run only one instance of the program only and do the same,"
    data IM;"but in this case the remote IP and port will be the local IP and Port."
    data IM;"This will send the data over the UDP and back again to the same and"
    data IM;"the same instance of the program....but this does not look very convincing"
    data IM;"that data has gone out and back in....so it is best to do this on either"
    data IM;"two separate machines or two instances of the program on the same machine.",""
    data IM;"To send data across the LAN you won't have to do any Fire Wall settings and "
    data IM;"the IPs are Local LAN IPs as set by your Router.",""
    data IM;"To send data over the internet you will need to setup the routers on both"
    data IM;"sides of the link so that the routers' firewalls would not block the"
    data IM;"ports required. Additionally, you need to tell the router to direct the data"
    data IM;"to the target machines.....HOWEVER....when you put the IP addresses you need"
    data IM;"to type in the IP address of the routers as they appear on the internet...."
    data IM;"your router's setup screen will show this or you can use a website (like"
    data IM;"http://www.whatismyip.com/) that tells you your internet IP.",""
    data IM;"This is not trivial and look for a PDF to be put out soon on how to do"
    data IM;"this on www.RobotBASIC.com.",""
    data IM;spaces(40)+"Have Fun!"
    InstFt = MsgBox(IM)
Return